=== debian/changelog ===
opencsg (1.5.0-1) unstable; urgency=medium

  * New upstream version 1.5.0
  * Update debian/copyright to reflect new GPL-2+ license for OpenCSG
  * Package cleanup (Standards-Version, dh version, lintians)

 -- Kristian Nielsen <knielsen@knielsen-hq.org>  Fri, 15 Apr 2022 18:23:24 +0200
