=== debian/control ===
Source: opencsg
Priority: optional
Maintainer: Christian M. Amsüss <chrysn@fsfe.org>
Uploaders: Kristian Nielsen <knielsen@knielsen-hq.org>
Build-Depends: debhelper-compat (= 13), freeglut3-dev, libboost-dev,
 libglew-dev, libxmu-dev, qt5-qmake, qtbase5-dev, rename
Standards-Version: 4.6.0
Rules-Requires-Root: no
Section: libs
Homepage: https://opencsg.org/
Vcs-Browser: https://salsa.debian.org/knielsen-guest/opencsg
Vcs-Git: https://salsa.debian.org/knielsen-guest/opencsg.git -b master

Package: libopencsg-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libopencsg1 (= ${binary:Version})
Description: image-based CSG library using OpenGL (development files)
 OpenCSG is a library for CSG (Constructive Solid Geometry) that can combine
 geometric primitives to more complex objects, for example the difference
 between two primitives. Instead of explicitly calculating the shape of the
 resulting object, it uses OpenGL's z-buffer to render the image.
 .
 OpenCSG implements both the Goldfeather and the SCS algorithm.
 .
 This package contains files needed to compile opencsg applications.

Package: libopencsg1
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: image-based CSG (Constructive Solid Geometry) library using OpenGL
 OpenCSG is a library for CSG (Constructive Solid Geometry) that can combine
 geometric primitives to more complex objects, for example the difference
 between two primitives. Instead of explicitly calculating the shape of the
 resulting object, it uses OpenGL's z-buffer to render the image.
 .
 OpenCSG implements both the Goldfeather and the SCS algorithm.
 .
 This package contains shared library files.

Package: libopencsg-example
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: foreign
Description: image-based CSG library using OpenGL (example program)
 OpenCSG is a library for CSG (Constructive Solid Geometry) that can combine
 geometric primitives to more complex objects, for example the difference
 between two primitives. Instead of explicitly calculating the shape of the
 resulting object, it uses OpenGL's z-buffer to render the image.
 .
 OpenCSG implements both the Goldfeather and the SCS algorithm.
 .
 This package contains a OpenCSG demo program.

Package: libopencsg1-dbg
Section: debug
Architecture: any
Depends: libopencsg1 (=${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: debugging symbols for libopencsg
 OpenCSG is a library for CSG (Constructive Solid Geometry) that can combine
 geometric primitives to more complex objects, for example the difference
 between two primitives. Instead of explicitly calculating the shape of the
 resulting object, it uses OpenGL's z-buffer to render the image.
 .
 OpenCSG implements both the Goldfeather and the SCS algorithm.
 .
 This package contains the debugging symbols for libopencsg.
