=== debian/watch ===
version=3

https://www.opencsg.org/OpenCSG-(.*)\.tar\.gz
